﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace Tasks.Services
{
    [DataContract(Namespace = "http://schemas.fabrikam.com/2008/04/tasks/")]
    public class FaultInfo
    {
        [DataMember()]
        public string Reason = null;
    }

    [ServiceContract(Name = "TaskManagerService",
                    Namespace = "http://schemas.fabrikam.com/2008/04/tasks/")]
    public interface ITaskManagerService
    {
        [OperationContract()]
        int AddTask(string taskDescription, string assignedTo);

        [OperationContract()]
        List<int> GetTasksByAssignedName(string assignedTo);

        [OperationContract()]
        [FaultContract(typeof(FaultInfo))]
        string GetTaskDescription(int taskNumber);

        [OperationContract()]
        [FaultContract(typeof(FaultInfo))]
        bool IsTaskCompleted(int taskNumber);

        // Note: This op can no longer be one-way because
        // we want to be able to return (SOAP) faults
        [OperationContract()]
        [FaultContract(typeof(FaultInfo))]
        void MarkTaskCompleted(int taskNumber);

        // Can't be one-way either
        [OperationContract()]
        [FaultContract(typeof(FaultInfo))]
        void DeleteTask(int taskNumber);
    }
}
