﻿Imports System.ServiceModel
Imports System.Collections.Generic
Imports System.Runtime.Serialization

<DataContract(Namespace:= _
    "http://schemas.fabrikam.com/2008/04/tasks/")> _
Public Class FaultInfo
    <DataMember()> _
    Public Reason As String = Nothing
End Class

<ServiceContract(Name:="TaskManagerService", _
        Namespace:="http://schemas.fabrikam.com/2008/04/tasks/")> _
Public Interface ITaskManagerService
    <OperationContract()> _
    Function AddTask(ByVal taskDescription As String, _
                ByVal assignedTo As String) As Integer

    <OperationContract()> _
    Function GetTasksByAssignedName( _
            ByVal assignedTo As String) As List(Of Integer)

    <OperationContract()> _
    <FaultContract(GetType(FaultInfo))> _
    Function GetTaskDescription(ByVal taskNumber As Integer) As String

    <OperationContract()> _
    <FaultContract(GetType(FaultInfo))> _
    Function IsTaskCompleted(ByVal taskNumber As Integer) As Boolean

    <OperationContract()> _
    <FaultContract(GetType(FaultInfo))> _
    Sub MarkTaskCompleted(ByVal taskNumber As Integer)

    <OperationContract()> _
    <FaultContract(GetType(FaultInfo))> _
    Sub DeleteTask(ByVal taskNumber As Integer)

End Interface
