﻿Imports System.ServiceModel.Dispatcher
Imports System.ServiceModel.Channels

Public Class DemoContextProvider
    Implements IInstanceContextProvider

    Dim contextMap As New Dictionary(Of String, DemoContextInfo)
    Dim headerName As String = "RequesterInstanceId"
    Dim headerNamespace As String = "http://tempuri.org/Shareable"

    Public Function GetExistingInstanceContext(ByVal message As Message, _
       ByVal channel As IContextChannel) As InstanceContext _
       Implements IInstanceContextProvider.GetExistingInstanceContext

        Dim headerIndex As Integer = message.Headers.FindHeader(headerName, _
    headerNamespace)

        Dim _instanceId As String = String.Empty
        If headerIndex <> -1 Then
            _instanceId = message.Headers.GetHeader(Of String)(headerIndex)
        End If

        Dim info As DemoContextInfo = Nothing
        Dim hasSession As Boolean = (channel.SessionId IsNot Nothing)
        If hasSession Then
            info = channel.Extensions.Find(Of DemoContextInfo)()
        End If

        Dim isNew As Boolean = False
        If String.IsNullOrEmpty(_instanceId) OrElse Not contextMap.TryGetValue(_instanceId, info) Then
            info = New DemoContextInfo(_instanceId)
            isNew = True
            contextMap.Add(_instanceId, info)
            If hasSession Then
                channel.Extensions.Add(info)
            End If
        End If

        If isNew Then
            Return Nothing
        Else
            Dim _instance As InstanceContext = info.Instance
            If hasSession Then
                _instance.IncomingChannels.Add(channel)
            End If
            Return _instance
        End If

    End Function

    Public Sub InitializeInstanceContext(ByVal instanceContext As InstanceContext, _
        ByVal message As Message, ByVal channel As IContextChannel) _
        Implements IInstanceContextProvider.InitializeInstanceContext

        Dim info As DemoContextInfo = Nothing
        Dim hasSession As Boolean = (channel.SessionId IsNot Nothing)

        If hasSession Then
            instanceContext.IncomingChannels.Add(channel)
            info = channel.Extensions.Find(Of DemoContextInfo)()
        Else
            Dim headerIndex As Integer = message.Headers.FindHeader(headerName, _
               headerNamespace)
            If headerIndex <> -1 Then
                Dim instanceId As String = _
                message.Headers.GetHeader(Of String)(headerIndex)
                If instanceId IsNot Nothing Then
                    contextMap.TryGetValue(instanceId, info)
                End If
            End If
        End If

        If info IsNot Nothing Then
            info.Instance = instanceContext
        End If

    End Sub

    Public Function IsIdle(ByVal instanceContext As InstanceContext) As Boolean _
       Implements System.ServiceModel.Dispatcher.IInstanceContextProvider.IsIdle

    End Function

    Public Sub NotifyIdle(ByVal callback As InstanceContextIdleCallback, _
       ByVal instanceContext As InstanceContext) _
       Implements System.ServiceModel.Dispatcher.IInstanceContextProvider.NotifyIdle

    End Sub
End Class
