﻿Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Transactions

Public Class Program

    Public Shared Sub Main()
        AppDomain.CurrentDomain.SetData("DataDirectory", _
            System.IO.Path.GetFullPath(System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "..\..\..")))
        Console.WriteLine(String.Format("Before starting, the record count is {0}", getRecordCount()))

        Using client As _
            New TransactionalClient.TransactionalServiceProxy.UpdateServiceClient()

            Try
                Using ts As New TransactionScope
                    client.UpdateWithTransaction( _
                       "INSERT INTO DemoTable VALUES (1, 'Demo Data')")
                    addRecord()
                    Console.WriteLine(String.Format("Before the abort, the record count is {0}", getRecordCount()))
                    ts.Dispose()
                    ' ts.Complete()
                End Using
            Catch ex As Exception
                Console.WriteLine(ex.Message)
            End Try

        End Using

        Console.WriteLine(String.Format("After the commit, the record count is {0}", getRecordCount()))
        Console.ReadLine()
    End Sub


#Region "Private Methods"

    Private Shared Function getRecordCount() As Integer

        Dim result As Integer

        Dim connectionString As String = _
            ConfigurationManager.ConnectionStrings("TK503").ConnectionString

        Using cn As New SqlConnection(connectionString)
            cn.Open()
            Dim cmd As New SqlCommand("SELECT COUNT(*) FROM DemoTable", cn)
            result = Convert.ToInt32(cmd.ExecuteScalar())
        End Using

        Return result
    End Function

    Private Shared Function addRecord() As Integer
        Dim result As Integer

        Dim connectionString As String = _
                ConfigurationManager.ConnectionStrings("TK503").ConnectionString
        Using cn As New SqlConnection(connectionString)
            cn.Open()
            Dim cmd As New SqlCommand("INSERT INTO DemoTable VALUES (3, 'Demo Data')", cn)
            result = Convert.ToInt32(cmd.ExecuteScalar())
        End Using

        Return result
    End Function

#End Region

End Class
