﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.Configuration;
using System.Data.SqlClient;
using System.Transactions;

namespace TransactionalService
{
    public class UpdateService : IUpdateService
    {

        #region IUpdateService Members

        public int UpdateNoTransaction(string sqlStmt)
        {
            return update(sqlStmt);
        }

        [OperationBehavior(TransactionScopeRequired = true, TransactionAutoComplete = true)]
        public int UpdateWithTransaction(string sqlStmt)
        {
            return update(sqlStmt);
        }

        #endregion

        #region Private Methods

        private int update(string sqlStmt)
        {
            AppDomain.CurrentDomain.SetData("DataDirectory",
                System.IO.Path.GetFullPath(System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"..\..\..")));
            int result = 0;
            using (TransactionScope ts = new TransactionScope(TransactionScopeOption.Required))
            {
                string connectionString =
                    ConfigurationManager.ConnectionStrings["TK503"].ConnectionString;
                using (SqlConnection cn = new SqlConnection(connectionString))
                {
                    try
                    {
                        cn.Open();
                        SqlCommand cmd = new SqlCommand(sqlStmt, cn);
                        result = cmd.ExecuteNonQuery();
                        ts.Complete();
                    }
                    catch (SqlException)
                    {
                    }
                }
            }
            return result;
        }

        #endregion
    }
}
