﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Transactions;
using System.Data.SqlClient;
using System.Configuration;

namespace TransactionalClient
{
    class Program
    {
        static void Main(string[] args)
        {
            AppDomain.CurrentDomain.SetData("DataDirectory",
                System.IO.Path.GetFullPath(System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"..\..\..")));
            Console.WriteLine(String.Format("Before starting, the record count is {0}", getRecordCount()));

            Console.WriteLine(String.Format("After the commit, the record count is {0}", getRecordCount()));
            Console.ReadLine();
        }

        #region Private Methods

        private static int getRecordCount()
        {
            int result;

                string connectionString =
                    ConfigurationManager.ConnectionStrings["TK503"].ConnectionString;
                using (SqlConnection cn = new SqlConnection(connectionString))
                {
                    cn.Open();
                    SqlCommand cmd = new SqlCommand("SELECT COUNT(*) FROM DemoTable", cn);
                    result = Convert.ToInt32(cmd.ExecuteScalar());
                }
            return result;
        }

        private static void showTransactionDetails(string tsName)
        {
            Console.WriteLine(String.Format("For transaction '{0}', the local identifier is {1}", tsName,
                Transaction.Current.TransactionInformation.LocalIdentifier));
        }

        #endregion
    }
}
