﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.ServiceModel.Channels;
using System.Diagnostics;
using DemoLibrary;
using System.Threading;

namespace DemoService
{
    [ServiceBehavior(ConcurrencyMode=ConcurrencyMode.Reentrant,
        InstanceContextMode=InstanceContextMode.Single)]
    public class ConcurrencyService : IConcurrency
    {
        string result = String.Empty;

        public string GetCallCount(int waitTime)
        {
            result = "Started at " + DateTime.Now.ToLongTimeString();
            ParameterizedThreadStart ts = new ParameterizedThreadStart(makeCallback);
            Thread t1 = new Thread(ts);
            t1.Start(OperationContext.Current.GetCallbackChannel<IConcurrencyCallback>());
            Thread t2 = new Thread(ts);
            t2.Start(OperationContext.Current.GetCallbackChannel<IConcurrencyCallback>());
            t1.Join();
            t2.Join();
            result += Environment.NewLine + "Finished at " + DateTime.Now.ToLongTimeString();

            return result;
        }
    }
}
