﻿Imports DemoLibrary
Imports System.Threading

<ServiceBehavior(ConcurrencyMode:=ConcurrencyMode.Reentrant, _
    InstanceContextMode:=InstanceContextMode.Single)> _
Public Class ConcurrencyService
    Implements IConcurrency

    Private result As String

    Public Function GetCallCount(ByVal waitTime As Integer) As String Implements IConcurrency.GetCallCount

        result = "Started at " + DateTime.Now.ToLongTimeString()
        Dim ts As New ParameterizedThreadStart(AddressOf makeCallback)
        Dim t1 As New Thread(ts)
        t1.Start(OperationContext.Current.GetCallbackChannel(Of IConcurrencyCallback)())
        Dim t2 As New Thread(ts)
        t2.Start(OperationContext.Current.GetCallbackChannel(Of IConcurrencyCallback)())
        t1.Join()
        t2.Join()
        result += Environment.NewLine & "Finished at " & DateTime.Now.ToLongTimeString()

        Return result

    End Function

    Private Sub makeCallback(ByVal callback As Object)
        callback.ReceiveCallCount(Thread.CurrentThread.ManagedThreadId)
        SyncLock Me
            result += Environment.NewLine & String.Format("Callback from {0} at {1}", _
                Thread.CurrentThread.ManagedThreadId, DateTime.Now.ToLongTimeString())
        End SyncLock
    End Sub
End Class
