﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.ServiceModel;
using System.ServiceModel.Channels;
using Tasks.Entities;
using Tasks.Services;

namespace DynGenProxy
{
    class Program
    {
        static void Main(string[] args)
        {
            Binding binding = new BasicHttpBinding();

            ChannelFactory<ITaskManagerService> factory;
            factory = new ChannelFactory<ITaskManagerService>(
                    binding, "http://localhost:8080/Tasks/TaskManager");

            try
            {
                ITaskManagerService proxy = factory.CreateChannel();

                Task task = new Task();
                task.CreatedBy = "Vicki";
                task.AssignedTo = "Ian";
                task.DateCreated = DateTime.Now;
                task.DateLastModified = DateTime.Now;
                task.Description = "Clean your room";
                task.DueDate = DateTime.Now.AddDays(3);

                TaskAcknowledgement ack = proxy.AddTask(task);

                Console.WriteLine(
                    "Task number {0} added to service",
                        ack.TaskNumber);
            }

            catch (Exception ex)
            {
                Console.WriteLine("Error: {0}",ex.Message);
            }
        }
    }
}
