﻿Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports SvcUtilProxy.SvcUtilProxy

Module Module1

    Sub Main()
        Dim proxy As TaskManagerServiceClient
        proxy = New TaskManagerServiceClient()

        Try
            Dim task As New Task()
            task.CreatedBy = "Eric"
            task.AssignedTo = "Ian"
            task.DateCreated = DateTime.Now
            task.DateLastModified = DateTime.Now
            task.Description = "Practice your saxophone"
            task.DueDate = DateTime.Now.AddDays(3)

            Dim cb As AsyncCallback
            cb = New AsyncCallback(AddressOf HandleTaskAdded)
            proxy.BeginAddTask(task, cb, proxy)

            Console.WriteLine("Asynchronously adding a task to the service" + _
                "Press any key to exit")
            Console.ReadLine()
        Catch ex As Exception
            Console.WriteLine("Error: {0}", ex.Message)
        End Try
    End Sub

    Sub HandleTaskAdded(ByVal ar As IAsyncResult)
        Dim proxy As TaskManagerServiceClient
        proxy = CType(ar.AsyncState, TaskManagerServiceClient)

        Dim ack As TaskAcknowledgement
        ack = proxy.EndAddTask(ar)

        Console.WriteLine( _
            "Task number {0} was added to service", _
            ack.TaskNumber)

    End Sub

End Module
