﻿Imports System.Runtime.Serialization

<DataContract(Namespace:= _
    "http://schemas.fabrikam.com/2008/04/tasks/")> _
Public Enum TaskStates
    <EnumMember()> _
    Active = 0

    <EnumMember()> _
    CompletedByDueDate = 1

    <EnumMember()> _
    CompletedPastDueDate = 2

    <EnumMember()> _
    Overdue = 3
End Enum

<DataContract(Namespace:= _
    "http://schemas.fabrikam.com/2008/04/tasks/")> _
Public Class FaultInfo
    <DataMember()> _
    Public Reason As String = Nothing
End Class

<DataContract(Namespace:= _
    "http://schemas.fabrikam.com/2008/04/tasks/")> _
Public Class Task
    Implements IExtensibleDataObject

    <DataMember(IsRequired:=False, Order:=0)> _
    Public TaskNumber As Integer

    <DataMember(IsRequired:=True, Order:=1)> _
    Public Description As String

    <DataMember(IsRequired:=False, Order:=2)> _
    Public TaskState As TaskStates

    <DataMember(IsRequired:=False, Order:=3)> _
    Public AssignedTo As String

    <DataMember(IsRequired:=False, Order:=4)> _
    Public CreatedBy As String

    <DataMember(IsRequired:=False, Order:=5)> _
    Public DateCreated As DateTime

    <DataMember(IsRequired:=False, Order:=6)> _
    Public DateLastModified As DateTime

    <DataMember(IsRequired:=False, Order:=7)> _
    Public DueDate As DateTime

    Public Overrides Function ToString() As String
        Return String.Format( _
                "Task: {0}\tAssigned to: {1}\tStatus: {2}\nDescription:\n{3}\nCreated By: {4}\tDate Created: {5}\tDate Last Modified: {6}\nDue Date: {7}", _
                TaskNumber, AssignedTo, _
                TaskState, Description, _
                CreatedBy, DateCreated, _
                DateLastModified, DueDate)
    End Function

    Public Property ExtensionData() _
        As ExtensionDataObject _
        Implements IExtensibleDataObject.ExtensionData
        Get
            Return _extensionData
        End Get

        Set(ByVal value As ExtensionDataObject)
            _extensionData = value
        End Set
    End Property

    Private _extensionData As ExtensionDataObject
End Class

<DataContract(Namespace:= _
    "http://schemas.fabrikam.com/2008/04/tasks/")> _
Public Class TaskAcknowledgement
    Implements IExtensibleDataObject

    <DataMember(IsRequired:=False, Order:=0)> _
    Public TaskNumber As Integer

    <DataMember(IsRequired:=False, Order:=1)> _
    Public CurrentState As TaskStates

    <DataMember(IsRequired:=False, Order:=2)> _
    Public Comments As String

    Public Property ExtensionData() _
        As ExtensionDataObject _
        Implements IExtensibleDataObject.ExtensionData
        Get
            Return _extensionData
        End Get

        Set(ByVal value As ExtensionDataObject)
            _extensionData = value
        End Set
    End Property

    Private _extensionData As ExtensionDataObject
End Class

