﻿Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports VSProxy.Tasks

Module Module1

    Sub Main()
        Dim proxy As TaskManagerServiceClient
        proxy = New TaskManagerServiceClient()

        Try
            Dim task As New Task()
            task.CreatedBy = "Eric"
            task.AssignedTo = "Vicki"
            task.DateCreated = DateTime.Now
            task.DateLastModified = DateTime.Now
            task.Description = "Do the laundry"
            task.DueDate = DateTime.Now.AddDays(3)

            Dim ack As TaskAcknowledgement
            ack = proxy.AddTask(task)

            Dim taskNum As Integer
            taskNum = ack.TaskNumber
            Console.WriteLine( _
                "Task number {0} added to service", _
                                    taskNum)

            ' Now try to mark that same task
            ' as completed:
            proxy.MarkTaskCompleted(taskNum)

        Catch fault As FaultException(Of FaultInfo)
            Console.WriteLine("Error: {0}", fault.Detail.Reason)
        End Try
    End Sub

End Module
