﻿Imports System.ServiceModel
Imports System.ServiceModel.Channels

<ServiceContract()> _
Public Interface IGreetingHandler
    <OperationContract(IsOneWay:=True)> _
    Sub GreetingProduced(ByVal greeting As String)
End Interface

<ServiceContract(CallbackContract:= _
                 GetType(IGreetingHandler))> _
Public Interface IGreetingService
    <OperationContract(IsOneWay:=True)> _
    Sub RequestGreeting(ByVal name As String)
End Interface

<ServiceBehavior(InstanceContextMode:=InstanceContextMode.PerSession)> _
Public Class GreetingService
    Implements IGreetingService

    Public Sub RequestGreeting(ByVal name As String) _
            Implements IGreetingService.RequestGreeting
        Console.WriteLine("In GreetingService.RequestGreeting")
        Dim cbh As IGreetingHandler
        cbh = OperationContext.Current.GetCallbackChannel( _
                                Of IGreetingHandler)()
        cbh.GreetingProduced("Hello " + name)
    End Sub
End Class
