﻿Public Class HeaderService
    Implements IGetHeaders

    Public Function GetHeaders() As String Implements IGetHeaders.GetHeaders
        Dim result As String = String.Empty
        Dim myHeaderIndex As Integer

        If Trace.CorrelationManager.ActivityId = Guid.Empty Then
            Trace.CorrelationManager.ActivityId = Guid.NewGuid()
        End If
        Dim ts As New TraceSource("DemoServiceTraceSource")
        ts.TraceEvent(TraceEventType.Start, 0, "GetHeader Activity")

        ts.TraceEvent(TraceEventType.Information, 0, _
            "Service receives GetHeader request message.")

        myHeaderIndex = _
           OperationContext.Current.RequestContext.RequestMessage. _
           Headers.FindHeader("MyHeader", "http://tempuri.org")

        If myHeaderIndex <> -1 Then
            result = OperationContext.Current.RequestContext.RequestMessage. _
                Headers.GetHeader(Of String)(myHeaderIndex)
        Else
            result = OperationContext.Current.RequestContext.RequestMessage. _
                Headers.Action
        End If

        ts.TraceEvent(TraceEventType.Information, 0, _
            "Service sends GetHeaders response message.")
        ts.TraceEvent(TraceEventType.Stop, 0, "GetHeader Activity")

        Return result

    End Function

End Class
