﻿Imports System.ServiceModel.Dispatcher
Imports System.ServiceModel.Channels
Imports System.ServiceModel

Public Class MessageTracer
    Implements IClientMessageInspector

    Private Function TraceMessage(ByVal buffer As MessageBuffer) As Message
        Dim msg As Message = buffer.CreateMessage()
        System.Diagnostics.Trace.WriteLine("Message contents " & msg.ToString())
        Return buffer.CreateMessage()
    End Function

    Public Function BeforeSendRequest(ByRef request As Message, _
       ByVal Channel As IClientChannel) As Object _
       Implements IClientMessageInspector.BeforeSendRequest

        request = TraceMessage(request.CreateBufferedCopy(Integer.MaxValue))
        Return Nothing
    End Function

    Public Sub AfterReceiveReply(ByRef reply As Message, _
       ByVal correlationState As Object) _
       Implements IClientMessageInspector.AfterReceiveReply
        reply = TraceMessage(reply.CreateBufferedCopy(Integer.MaxValue))
    End Sub

End Class
