﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Dispatcher;
using System.ServiceModel;
using System.Text.RegularExpressions;

namespace DemoService
{
    public class PhoneNumberParameterValidator : IParameterInspector
    {
        int phoneNumberParamIndex;
        string phoneNumberFormat = 
            @"^(?:\([2-9]\d{2}\)\ ?|[2-9]\d{2}(?:\-?|\ ?))[2-9]\d{2}[- ]?\d{4}$";

        public PhoneNumberParameterValidator() : this(0) { }

        public PhoneNumberParameterValidator(int phoneNumberParamIndex)
        {
            this.phoneNumberParamIndex = phoneNumberParamIndex;
        }

        public void AfterCall(string operationName, object[] outputs, object returnValue, object correlationState)
        { }

        public object BeforeCall(string operationName, object[] inputs)
        {
            string phoneNumberParam = inputs[phoneNumberParamIndex] as string;
            if (!Regex.IsMatch(phoneNumberParam, phoneNumberFormat, RegexOptions.None))
                throw new FaultException("Invalid phone number. Required format: ###-###-####");
            return null;
        }
    }
}