﻿Imports System.IdentityModel.Policy
Imports System.IdentityModel.Claims
Imports System.Security.Principal

Public Class SpecificRoleAuthorizationPolicy
    Implements IAuthorizationPolicy

    Dim _id As String
    Dim _issuer As ClaimSet

    Public Sub New()
        _id = Guid.NewGuid().ToString()
        _issuer = ClaimSet.System
    End Sub

    Public ReadOnly Property Id() As String _
        Implements IAuthorizationPolicy.Id
        Get
            Return _id
        End Get
    End Property

    Public ReadOnly Property Issuer() As ClaimSet _
        Implements IAuthorizationPolicy.Issuer
        Get
            Return _issuer
        End Get
    End Property

    Public Function Evaluate(ByVal context As EvaluationContext, _
   ByRef state As Object) As Boolean Implements IAuthorizationPolicy.Evaluate
        Dim prop As Object = Nothing
        If Not context.Properties.TryGetValue("Identities", prop) Then
            Return False
        End If

        Dim identities As List(Of IIdentity) = TryCast(prop, List(Of IIdentity))
        If identities Is Nothing OrElse identities.Count = 0 Then
            Return False
        End If

        context.Properties("Principal") = New GenericPrincipal(identities(0), _
           New String() {"HeaderPeople"})

        Return True

    End Function

End Class
